using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using System.Runtime.CompilerServices;
using Exferia_General._0_Modelos;
using Exferia_General.General;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._3_Vistas.Listados
{
    public class ABS_Listado_GEN_ConfiguracionesEmails : ABS_Listado
    {
        //Variables privadas
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_GEN_ConfiguracionesEmails()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.codigo), "código", G_ENUM_TIPOSDATOS.LONG_TEXT, false, 0, true, true, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.email), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.email), "email", G_ENUM_TIPOSDATOS.TEXT, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.descripcion), "descripcion", G_ENUM_TIPOSDATOS.TEXT, false, 200, true, true, true, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.nombreAMostrar), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.nombreAMostrar), "nombre a mostrar", G_ENUM_TIPOSDATOS.TEXT, false, 200, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_Servidor), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_Servidor), "SMTP Servidor", G_ENUM_TIPOSDATOS.TEXT, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_Puerto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_Puerto), "SMTP Puerto", G_ENUM_TIPOSDATOS.TEXT, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_RequiereAutenticacion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_RequiereAutenticacion), "SMTP Requiere Autenticacion", G_ENUM_TIPOSDATOS.BOOLEAN, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_Usuario), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_Usuario), "SMTP Usuario", G_ENUM_TIPOSDATOS.TEXT, false, 0, true, false, false, false, "", null));
           
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_ConexionSSL), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.smtp_ConexionSSL), "SMTP ConexionSSL", G_ENUM_TIPOSDATOS.BOOLEAN, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3), "POP3", G_ENUM_TIPOSDATOS.BOOLEAN, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3_Servidor), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3_Servidor), "POP3 Servidor", G_ENUM_TIPOSDATOS.TEXT, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3_Puerto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3_Puerto), "POP3 Puerto", G_ENUM_TIPOSDATOS.TEXT, false, 0, true, false, false, false, "", null));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3_Usuario), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.pop3_Usuario), "POP3 Usuario", G_ENUM_TIPOSDATOS.TEXT, false, 0, true, false, false, false, "", null));
           

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_GEN_CONFIGURACIONEMAIL);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_GEN_CONFIGURACIONEMAIL;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_GEN_ConfiguracionesEmails_Listado_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
